# PGN Attack Method

This document will show you how to use the code.  The program is running on a GPU environment.

## Requirements
* Python == 3.7.11
* pytorch == 1.8.0
* torchvision == 0.8.0
* numpy == 1.21.2
* pandas == 1.3.5
* opencv-python == 4.5.4.60
* scipy == 1.7.3
* pillow == 8.4.0
* pretrainedmodels == 0.7.4
* tqdm == 4.62.3
* imageio == 2.6.1


## Qucik Start
### Prepare the dataset and models.
We have prepared the ImageNet-compatible dataset in this program and put the data in **'./dataset/'**.

The models (i.e., Inc-v3, Inc-v4, IncRes-v2, Res-50, Res-101, Res-100) are from "pretrainedmodels", if you use it for the first time, it will download the weight of the model automatically, just wait for it to finish.

### Runing attack
1. You can run our proposed attack as follows. 

    python Incv3_PGN_Attack.py

2. The generated adversarial examples would be stored in the directory **./incv3_xx_xx_outputs**. Then run the file **verify.py** to evaluate the attack success rate of each model used in the paper:

    python verify.py

3. You can run the file **'surfce_map.py'** to visualize the loss surface maps for the adversarial examples, the maps will be stored in the directory **'./incv3_pgn_outputs/'**.

    python surfce_map.py